<template>
	<v-layout v-if="images.length > 0" fill-height row align-start justify-center>
		<v-flex xs12 sm6 md4 v-for="img in pagedImages" :key="img" @click.stop="onImageClick(img)">
			<v-img :class="{ selected: isSelected(img) }" :src="img" :aspect-ratio="16/9" />
		</v-flex>
		<v-pagination v-if="pageCount > 1" v-model="page" :length="pageCount" />
	</v-layout>
	<v-layout v-else fill-height row align-start justify-center>
		<v-flex xs12>
			<v-card>
				<v-card-title>No images available</v-card-title>
			</v-card>
		</v-flex>
	</v-layout>
</template>

<script>
const defaults = {
	value: () => [],
	multiSelect: false,
	images: []
};

export default {
	props: {
		value: {
			type: [Array, String],
			default: defaults.value
		},

		multiSelect: {
			type: Boolean,
			default: defaults.multiSelect
		},

		images: {
			type: Array,
			default: defaults.images
		}
	},

	data() {
		return {
			selected: this.value,
			page: 1
		};
	},

	computed: {
		pageSize() {
			if (this.$vuetify.breakpoint.xsOnly) return 1;
			else if (this.$vuetify.breakpoint.smAndDown) return 2;
			else if (this.$vuetify.breakpoint.mdAndDown) return 6;
			return 12;
		},

		pagedImages() {
			const start = (this.page - 1) * this.pageSize;
			const stop = start + this.pageSize;
			return this.images.slice(start, stop);
		},

		pageCount() {
			return Math.ceil(this.images.length / this.pageSize);
		}
	},

	methods: {
		onImageClick(index) {
			if (this.multiSelect) this.addMultiSelect(index);
			else this.addSingleSelect(index);

			this.$emit("input", this.selected);
		},

		addMultiSelect(item) {
			const filtered = this.selected.filter(v => v !== item);

			if (filtered.length === this.selected.length) this.selected.push(item);
			else this.selected = filtered;
		},

		addSingleSelect(item) {
			this.selected = item;
		},

		isSelected(index) {
			return (
				this.selected === index ||
				(this.multiSelect && this.selected.indexOf(index) >= 0)
			);
		}
	}
};
</script>

<style lang="scss" scoped>
.selected {
	border: 0.2rem solid;
	border-color: var(--v-primary-base);
}
</style>